$(() => {
const validationGroups = ['dates', 'guests', 'roomAndMealPlan'];
let confirmed = false;
let formData = getInitialFormData();
const stepper = $('#stepper').dxStepper({
items: steps,
onSelectionChanged(e) {
const selectedIndex = e.component.option('selectedIndex');
setSelectedIndex(selectedIndex);
},
onSelectionChanging(args) {
const { component, addedItems, removedItems } = args;
const { items = [] } = component.option();
const addedIndex = items.findIndex((item) => item === addedItems[0]);
const removedIndex = items.findIndex((item) => item === removedItems[0]);
const isMoveForward = addedIndex > removedIndex;
if (isMoveForward && validateStep(removedIndex) === false) {
args.cancel = true;
}
},
}).dxStepper('instance');
const multiViewItems = [
{ template: getDatesForm() },
{ template: getGuestsForm() },
{ template: getRoomAndMealForm() },
{ template: getAdditionalRequestsForm() },
{ template: getConfirmationTemplate() },
];
const stepContent = $('#stepContent').dxMultiView({
animationEnabled: false,
focusStateEnabled: false,
swipeEnabled: false,
height: 400,
items: multiViewItems,
}).dxMultiView('instance');
const prevButton = $('#prevButton').dxButton({
text: 'Back',
type: 'normal',
width: 100,
onClick: () => {
const selectedIndex = stepper.option('selectedIndex');
setSelectedIndex(selectedIndex - 1);
},
visible: false,
}).dxButton('instance');
const nextButton = $('#nextButton').dxButton({
text: 'Next',
type: 'default',
width: 100,
onClick: () => {
const selectedIndex = stepper.option('selectedIndex');
if (selectedIndex < steps.length - 1) {
if (validateStep(selectedIndex)) {
setSelectedIndex(selectedIndex + 1);
}
} else if (confirmed) {
reset();
} else {
confirm();
}
},
}).dxButton('instance');
function validateStep(index) {
const isValid = getValidationResult(index);
stepper.option(`items[${index}].isValid`, isValid);
return isValid;
}
function setSelectedIndex(index) {
stepper.option('selectedIndex', index);
stepContent.option('selectedIndex', index);
setCurrentStepCaption(index);
updateStepNavigationButtons(index);
if (index === steps.length - 1) {
stepContent.option('items[4].template', getConfirmationTemplate());
}
}
function reset() {
confirmed = false;
resetStepperState();
formData = getInitialFormData();
stepContent.repaint();
setSelectedIndex(0);
}
function confirm() {
confirmed = true;
setStepperReadonly(true);
validateStep(steps.length - 1);
setSelectedIndex(steps.length - 1);
}
function getValidationResult(index) {
if (index >= validationGroups.length) {
return true;
}
return DevExpress.validationEngine.validateGroup(validationGroups[index]).isValid;
}
function setCurrentStepCaption(index) {
if (confirmed) {
$('.current-step').empty();
} else if (!$('.current-step').text()) {
$('.current-step').append(`Step <span class="selected-index">${index + 1}</span> of ${steps.length}`);
} else {
$('.selected-index').text(index + 1);
}
}
function updateStepNavigationButtons(index) {
const isLastStep = index === steps.length - 1;
const lastStepNextButtonText = confirmed ? 'Reset' : 'Confirm';
const nextButtonText = isLastStep ? lastStepNextButtonText : 'Next';
prevButton.option('visible', !!index && !confirmed);
nextButton.option('text', nextButtonText);
}
function setStepperReadonly(readonly) {
stepper.option('focusStateEnabled', !readonly);
if (readonly) {
stepper.option('elementAttr', { class: 'readonly' });
} else {
stepper.resetOption('elementAttr');
}
}
function resetStepperState() {
stepper.beginUpdate();
for (let i = 0; i < steps.length; i += 1) {
stepper.option(`items[${i}].isValid`, undefined);
}
setStepperReadonly(false);
stepper.endUpdate();
}
function getDatesForm() {
return () => $('<div>').append(
$('<p>').text('Select your check-in and check-out dates. If your dates are flexible, include that information in Additional Requests. We will do our best to suggest best pricing options, depending on room availability.'),
$('<div>').dxForm({
formData,
validationGroup: validationGroups[0],
items: [{
dataField: 'dates',
editorType: 'dxDateRangeBox',
editorOptions: {
elementAttr: { id: 'datesPicker' },
startDatePlaceholder: 'Check-in',
endDatePlaceholder: 'Check-out',
},
isRequired: true,
label: { visible: false },
}],
}),
);
}
function getGuestsForm() {
return () => {
const getNumberBoxOptions = (options) => ({
editorType: 'dxNumberBox',
...options,
editorOptions: {
showSpinButtons: true,
min: 0,
max: 5,
...options.editorOptions,
},
label: {
location: 'top',
...options.label,
},
});
return $('<div>').append(
$('<p>').text('Enter the number of adults, children, and pets staying in the room. This information help us suggest suitable room types, number of beds, and included amenities.'),
$('<div>').dxForm({
formData,
validationGroup: validationGroups[1],
colCount: 3,
items: [
getNumberBoxOptions({
dataField: 'adultsCount',
isRequired: true,
label: { text: 'Adults' },
editorOptions: {
elementAttr: { id: 'adultsCount' },
},
validationRules: [{
type: 'range',
min: 1,
}],
}),
getNumberBoxOptions({
dataField: 'childrenCount',
label: { text: 'Children' },
}),
getNumberBoxOptions({
dataField: 'petsCount',
label: { text: 'Pets' },
}),
],
}),
);
};
}
function getRoomAndMealForm() {
return () => {
const getSelectBoxOptions = (options) => ({
editorType: 'dxSelectBox',
isRequired: true,
...options,
label: {
location: 'top',
...options.label,
},
});
return $('<div>').append(
$('<p>').text('Review room types that can accommodate your group size and make your selection. You can also choose a meal plan, whether it\'s breakfast only or full board.'),
$('<div>').dxForm({
formData,
validationGroup: validationGroups[2],
colCount: 2,
items: [
getSelectBoxOptions({
dataField: 'roomType',
editorOptions: {
items: roomTypes,
elementAttr: { id: 'roomType' },
},
label: { text: 'Room Type' },
}),
getSelectBoxOptions({
dataField: 'mealPlan',
editorOptions: {
items: mealPlans,
elementAttr: { id: 'mealPlan' },
},
label: { text: 'Meal Plan' },
}),
],
}),
);
};
}
function getAdditionalRequestsForm() {
return () => $('<div>').append(
$('<div>').text('Please let us know if you have any other requests.'),
$('<div>').dxForm({
formData,
items: [
{
dataField: 'additionalRequest',
editorType: 'dxTextArea',
editorOptions: {
height: 160,
elementAttr: { id: 'additionalRequest' },
},
label: { visible: false },
},
],
}),
);
}
function getConfirmationTemplate() {
return () => {
if (confirmed) {
return '<div class="summary-item-header center">Your booking request was submitted.</div>';
}
const summaryContainer = $('<div class="summary-container">');
const datesData = $(`
<div class="summary-item">
<div class="summary-item-header">Dates</div>
<div class="separator"></div>
<div><span class="summary-item-label">Check-in Date: </span>${new Date(formData.dates[0]).toLocaleDateString()}</div>
<div><span class="summary-item-label">Check-out Date: </span>${new Date(formData.dates[1]).toLocaleDateString()}</div>
</div>
`);
const guestsData = $(`
<div class="summary-item">
<div class="summary-item-header">Guests</div>
<div class="separator"></div>
<div><span class="summary-item-label">Adults: </span>${formData.adultsCount}</div>
<div><span class="summary-item-label">Children: </span>${formData.childrenCount}</div>
<div><span class="summary-item-label">Pets: </span>${formData.petsCount}</div>
</div>
`);
const roomAndMealData = $(`
<div class="summary-item">
<div class="summary-item-header">Room and Meals</div>
<div class="separator"></div>
<div><span class="summary-item-label">Room Type: </span>${formData.roomType}</div>
<div><span class="summary-item-label">Check-out Date: </span>${formData.mealPlan}</div>
</div>
`);
summaryContainer.append(datesData, guestsData, roomAndMealData);
if (formData.additionalRequest) {
const additionalRequestsData = $(`
<div class="summary-item">
<div class="summary-item-header">Additional Requests</div>
<div class="separator"></div>
<div>${formData.additionalRequest}</div>
</div>
`);
summaryContainer.append(additionalRequestsData);
}
return summaryContainer;
};
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" />
<script src="js/dx.all.debug.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="stepper"></div>
<div class="content">
<div id="stepContent"></div>
<div class="nav-panel">
<div class="current-step"> Step <span class="selected-index">1</span> of 5</div>
<div class="nav-buttons">
<div id="prevButton"></div>
<div id="nextButton"></div>
</div>
</div>
</div>
</div>
</body>
</html>
.demo-container {
display: flex;
flex-direction: column;
justify-content: center;
row-gap: 20px;
height: 580px;
min-height: 480px;
min-width: 620px;
}
.content {
padding-inline: 40px;
flex: 1;
display: flex;
flex-direction: column;
row-gap: 20px;
}
.dx-multiview-item-content:has(> .summary-container) {
overflow: auto;
}
.summary-container {
display: flex;
flex-direction: column;
row-gap: 20px;
}
.summary-item {
display: flex;
flex-direction: column;
row-gap: 8px;
}
.summary-item-header {
font-weight: 600;
font-size: var(--dx-font-size-sm);
}
.center {
text-align: center;
}
.summary-item-label {
color: var(--dx-color-icon);
}
.separator {
width: 100%;
height: 1px;
border-bottom: solid 1px var(--dx-color-border);
}
.nav-panel {
display: flex;
align-items: center;
justify-content: space-between;
}
.current-step {
color: var(--dx-color-icon);
}
.nav-buttons {
display: flex;
gap: 8px;
}
.readonly {
pointer-events: none;
}
const steps = [
{
label: 'Dates', hint: 'Dates', icon: 'daterangepicker',
},
{
label: 'Guests', hint: 'Guests', icon: 'group',
},
{
label: 'Room and Meal Plan', hint: 'Room and Meal Plan', icon: 'servicebell',
},
{
label: 'Additional Requests', hint: 'Additional Requests', icon: 'clipboardtasklist', optional: true,
},
{
label: 'Confirmation', hint: 'Confirmation', icon: 'checkmarkcircle',
},
];
const roomTypes = ['Single', 'Double', 'Suite'];
const mealPlans = ['Bed & Breakfast', 'Half Board', 'Full Board', 'All-Inclusive'];
const initialFormData = {
dates: [null, null],
adultsCount: 0,
childrenCount: 0,
petsCount: 0,
roomType: undefined,
mealPlan: undefined,
additionalRequest: '',
};
const getInitialFormData = () => ({
...initialFormData,
dates: [...initialFormData.dates],
});

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React Stepper - Form Integration

This demo uses the DevExtreme Stepper component to guide users through a multi-page hotel registration form. The Stepper lacks a built-in form but can connect to it or other controls through APIs. Input controls at each step are organized using DevExtreme MultiView and Form components.

There are three key parts to this demo:

  • Stepper
  • Step content where the MultiView component displays content for each step. Each view with input fields contains a Form.
  • A navigation panel that displays the current step ("Step 1 of 5") and buttons for moving between steps (Next/Back).
Backend API
import React, { useState, useCallback, useMemo } from 'react'; import { Stepper, Item, type StepperTypes } from 'devextreme-react/stepper'; import { Button } from 'devextreme-react/button'; import { MultiView } from 'devextreme-react/multi-view'; import validationEngine from 'devextreme/ui/validation_engine'; import DatesForm from './DatesForm.tsx'; import GuestsForm from './GuestsForm.tsx'; import RoomMealPlanForm from './RoomMealPlanForm.tsx'; import AdditionalForm from './AdditionalForm.tsx'; import Confirmation from './Confirmation.tsx'; import { initialSteps, getInitialFormData } from './data.ts'; import type { BookingFormData } from './types.ts'; const validationGroups: string[] = ['dates', 'guests', 'roomAndMealPlan']; export default function App() { const [selectedIndex, setSelectedIndex] = useState<number>(0); const [steps, setSteps] = useState<StepperTypes.Item[]>(initialSteps); const [formData, setFormData] = useState<BookingFormData>(getInitialFormData); const [isConfirmed, setIsConfirmed] = useState<boolean>(false); const [isStepperReadonly, setIsStepperReadonly] = useState<boolean>(false); const getValidationResult = useCallback((index: number): boolean | undefined => { if (index >= validationGroups.length) { return true; } return validationEngine.validateGroup(validationGroups[index]).isValid; }, []); const setStepValidationResult = useCallback((index: number, isValid: boolean | undefined): void => { setSteps((prev) => prev.map((step, i: number) => { if (i === index) { return { ...step, isValid, }; } return step; })); }, []); const onPrevButtonClick = useCallback(() => { setSelectedIndex((prev: number): number => prev - 1); }, []); const moveNext = useCallback(() => { const isValid = getValidationResult(selectedIndex); setStepValidationResult(selectedIndex, isValid); if (isValid) { setSelectedIndex(selectedIndex + 1); } }, [getValidationResult, selectedIndex, setStepValidationResult]); const onConfirm = useCallback(() => { setIsConfirmed(true); setStepValidationResult(initialSteps.length - 1, true); setIsStepperReadonly(true); }, [setStepValidationResult]); const onReset = useCallback(() => { setIsConfirmed(false); setSteps(initialSteps); setSelectedIndex(0); setFormData(getInitialFormData); setIsStepperReadonly(false); }, []); const onNextButtonClick = useCallback(() => { if (selectedIndex < initialSteps.length - 1) { moveNext(); } else if (isConfirmed) { onReset(); } else { onConfirm(); } }, [selectedIndex, isConfirmed, onConfirm, onReset, moveNext]); const nextButtonText = useMemo((): string => { if (selectedIndex < steps.length - 1) { return 'Next'; } if (isConfirmed) { return 'Reset'; } return 'Confirm'; }, [selectedIndex, isConfirmed, steps.length]); const onSelectionChanging = useCallback((args: StepperTypes.SelectionChangingEvent): void => { const { component, addedItems, removedItems } = args; const { items = [] } = component.option(); const addedIndex = items.findIndex((item: StepperTypes.Item) => item === addedItems[0]); const removedIndex = items.findIndex((item: StepperTypes.Item) => item === removedItems[0]); const isMoveForward = addedIndex > removedIndex; if (isMoveForward) { const isValid = getValidationResult(removedIndex); setStepValidationResult(removedIndex, isValid); if (isValid === false) { args.cancel = true; } } }, [setStepValidationResult, getValidationResult]); const onSelectionChanged = useCallback(({ component }: StepperTypes.SelectionChangedEvent): void => { setSelectedIndex(component.option('selectedIndex') ?? 0); }, []); const renderDatesForm = useCallback( () => <DatesForm formData={formData} validationGroup={validationGroups[0]} />, [formData] ); const renderGuestsForm = useCallback( () => <GuestsForm formData={formData} validationGroup={validationGroups[1]} />, [formData] ); const renderRoomMealPlanForm = useCallback( () => <RoomMealPlanForm formData={formData} validationGroup={validationGroups[2]} />, [formData] ); const renderAdditionalForm = useCallback( () => <AdditionalForm formData={formData} />, [formData] ); const renderConfirmation = useCallback( () => <Confirmation formData={formData} isConfirmed={isConfirmed} />, [formData, isConfirmed] ); return ( <> <Stepper className={ isStepperReadonly ? 'readonly' : ''} focusStateEnabled={!isStepperReadonly} selectedIndex={selectedIndex} onSelectionChanged={onSelectionChanged} onSelectionChanging={onSelectionChanging} > {steps.map((step) => <Item key={step.label} {...step} />)} </Stepper> <div className="content"> <MultiView selectedIndex={selectedIndex} focusStateEnabled={false} animationEnabled={false} swipeEnabled={false} height={400} > <Item render={renderDatesForm} /> <Item render={renderGuestsForm} /> <Item render={renderRoomMealPlanForm} /> <Item render={renderAdditionalForm} /> <Item render={renderConfirmation} /> </MultiView> <div className="nav-panel"> <div className="current-step"> {!isConfirmed && ( <> Step <span className="selected-index">{selectedIndex + 1}</span> {' of '} {steps.length} </> )} </div> <div className="nav-buttons"> <Button id="prevButton" text="Back" type="normal" onClick={onPrevButtonClick} visible={selectedIndex !== 0 && !isConfirmed} width={100} /> <Button id="nextButton" text={nextButtonText} type="default" onClick={onNextButtonClick} width={100} /> </div> </div> </div> </> ); }
import React, { useState, useCallback, useMemo } from 'react'; import { Stepper, Item } from 'devextreme-react/stepper'; import { Button } from 'devextreme-react/button'; import { MultiView } from 'devextreme-react/multi-view'; import validationEngine from 'devextreme/ui/validation_engine'; import DatesForm from './DatesForm.js'; import GuestsForm from './GuestsForm.js'; import RoomMealPlanForm from './RoomMealPlanForm.js'; import AdditionalForm from './AdditionalForm.js'; import Confirmation from './Confirmation.js'; import { initialSteps, getInitialFormData } from './data.js'; const validationGroups = ['dates', 'guests', 'roomAndMealPlan']; export default function App() { const [selectedIndex, setSelectedIndex] = useState(0); const [steps, setSteps] = useState(initialSteps); const [formData, setFormData] = useState(getInitialFormData); const [isConfirmed, setIsConfirmed] = useState(false); const [isStepperReadonly, setIsStepperReadonly] = useState(false); const getValidationResult = useCallback((index) => { if (index >= validationGroups.length) { return true; } return validationEngine.validateGroup(validationGroups[index]).isValid; }, []); const setStepValidationResult = useCallback((index, isValid) => { setSteps((prev) => prev.map((step, i) => { if (i === index) { return { ...step, isValid, }; } return step; }), ); }, []); const onPrevButtonClick = useCallback(() => { setSelectedIndex((prev) => prev - 1); }, []); const moveNext = useCallback(() => { const isValid = getValidationResult(selectedIndex); setStepValidationResult(selectedIndex, isValid); if (isValid) { setSelectedIndex(selectedIndex + 1); } }, [getValidationResult, selectedIndex, setStepValidationResult]); const onConfirm = useCallback(() => { setIsConfirmed(true); setStepValidationResult(initialSteps.length - 1, true); setIsStepperReadonly(true); }, [setStepValidationResult]); const onReset = useCallback(() => { setIsConfirmed(false); setSteps(initialSteps); setSelectedIndex(0); setFormData(getInitialFormData); setIsStepperReadonly(false); }, []); const onNextButtonClick = useCallback(() => { if (selectedIndex < initialSteps.length - 1) { moveNext(); } else if (isConfirmed) { onReset(); } else { onConfirm(); } }, [selectedIndex, isConfirmed, onConfirm, onReset, moveNext]); const nextButtonText = useMemo(() => { if (selectedIndex < steps.length - 1) { return 'Next'; } if (isConfirmed) { return 'Reset'; } return 'Confirm'; }, [selectedIndex, isConfirmed, steps.length]); const onSelectionChanging = useCallback( (args) => { const { component, addedItems, removedItems } = args; const { items = [] } = component.option(); const addedIndex = items.findIndex((item) => item === addedItems[0]); const removedIndex = items.findIndex((item) => item === removedItems[0]); const isMoveForward = addedIndex > removedIndex; if (isMoveForward) { const isValid = getValidationResult(removedIndex); setStepValidationResult(removedIndex, isValid); if (isValid === false) { args.cancel = true; } } }, [setStepValidationResult, getValidationResult], ); const onSelectionChanged = useCallback(({ component }) => { setSelectedIndex(component.option('selectedIndex') ?? 0); }, []); const renderDatesForm = useCallback( () => ( <DatesForm formData={formData} validationGroup={validationGroups[0]} /> ), [formData], ); const renderGuestsForm = useCallback( () => ( <GuestsForm formData={formData} validationGroup={validationGroups[1]} /> ), [formData], ); const renderRoomMealPlanForm = useCallback( () => ( <RoomMealPlanForm formData={formData} validationGroup={validationGroups[2]} /> ), [formData], ); const renderAdditionalForm = useCallback( () => <AdditionalForm formData={formData} />, [formData], ); const renderConfirmation = useCallback( () => ( <Confirmation formData={formData} isConfirmed={isConfirmed} /> ), [formData, isConfirmed], ); return ( <> <Stepper className={isStepperReadonly ? 'readonly' : ''} focusStateEnabled={!isStepperReadonly} selectedIndex={selectedIndex} onSelectionChanged={onSelectionChanged} onSelectionChanging={onSelectionChanging} > {steps.map((step) => ( <Item key={step.label} {...step} /> ))} </Stepper> <div className="content"> <MultiView selectedIndex={selectedIndex} focusStateEnabled={false} animationEnabled={false} swipeEnabled={false} height={400} > <Item render={renderDatesForm} /> <Item render={renderGuestsForm} /> <Item render={renderRoomMealPlanForm} /> <Item render={renderAdditionalForm} /> <Item render={renderConfirmation} /> </MultiView> <div className="nav-panel"> <div className="current-step"> {!isConfirmed && ( <> Step <span className="selected-index">{selectedIndex + 1}</span> {' of '} {steps.length} </> )} </div> <div className="nav-buttons"> <Button id="prevButton" text="Back" type="normal" onClick={onPrevButtonClick} visible={selectedIndex !== 0 && !isConfirmed} width={100} /> <Button id="nextButton" text={nextButtonText} type="default" onClick={onNextButtonClick} width={100} /> </div> </div> </div> </> ); }
import React, { memo } from 'react'; import type { FC } from 'react'; import 'devextreme-react/text-area'; import { Form, SimpleItem } from 'devextreme-react/form'; import type { FormProps } from './types.ts'; const AdditionalForm: FC<FormProps> = memo(({ formData }: FormProps) => ( <> <div> Please let us know if you have any other requests. </div> <Form formData={formData}> <SimpleItem dataField='additionalRequest' editorType='dxTextArea' editorOptions={{ height: 160, elementAttr: { id: 'additionalRequest' }, }} label={{ visible: false }} ></SimpleItem> </Form> </> )); AdditionalForm.displayName = 'AdditionalForm'; export default AdditionalForm;
import React from 'react'; import type { FC } from 'react'; import 'devextreme-react/date-range-box'; import type { BookingFormData } from './types.ts'; interface ConfirmationProps { formData: BookingFormData; isConfirmed: boolean; } const Confirmation: FC<ConfirmationProps> = ({ formData, isConfirmed }: ConfirmationProps) => { if (isConfirmed) { return ( <div className="summary-item-header center"> Your booking request was submitted. </div> ); } return ( <div className="summary-container"> <div className="summary-item"> <div className="summary-item-header">Dates</div> <div className="separator"></div> <div> <span className="summary-item-label">Check-in Date: </span>{new Date(formData.dates[0] ?? '').toLocaleDateString()} </div> <div> <span className="summary-item-label">Check-out Date: </span>{new Date(formData.dates[1] ?? '').toLocaleDateString()} </div> </div> <div className="summary-item"> <div className="summary-item-header">Guests</div> <div className="separator"></div> <div><span className="summary-item-label">Adults: </span>{formData.adultsCount}</div> <div><span className="summary-item-label">Children: </span>{formData.childrenCount}</div> <div><span className="summary-item-label">Pets: </span>{formData.petsCount}</div> </div> <div className="summary-item"> <div className="summary-item-header">Room and Meals</div> <div className="separator"></div> <div><span className="summary-item-label">Room Type: </span>{formData.roomType}</div> <div><span className="summary-item-label">Check-out Date: </span>{formData.mealPlan}</div> </div> {!!formData.additionalRequest && ( <div className="summary-item"> <div className="summary-item-header">Additional Requests</div> <div className="separator"></div> <div>{formData.additionalRequest}</div> </div> )} </div> ); }; Confirmation.displayName = 'Confirmation'; export default Confirmation;
import React, { memo } from 'react'; import type { FC } from 'react'; import 'devextreme-react/date-range-box'; import { Form, SimpleItem } from 'devextreme-react/form'; import type { FormProps } from './types.ts'; const DatesForm: FC<FormProps> = memo(({ formData, validationGroup }: FormProps) => ( <> <p> Select your check-in and check-out dates. If your dates are flexible, include that information in Additional Requests. We will do our best to suggest best pricing options, depending on room availability. </p> <Form formData={formData} validationGroup={validationGroup}> <SimpleItem isRequired dataField='dates' editorType='dxDateRangeBox' editorOptions={{ startDatePlaceholder: 'Check-in', endDatePlaceholder: 'Check-out', elementAttr: { id: 'datesPicker' }, }} label={{ visible: false }} /> </Form> </> )); DatesForm.displayName = 'DatesForm'; export default DatesForm;
import React, { memo } from 'react'; import type { FC } from 'react'; import { Form, RangeRule, SimpleItem } from 'devextreme-react/form'; import 'devextreme-react/number-box'; import type { FormProps } from './types.ts'; const GuestsForm: FC<FormProps> = memo(({ formData, validationGroup }: FormProps) => ( <> <p> Enter the number of adults, children, and pets staying in the room. This information help us suggest suitable room types, number of beds, and included amenities. </p> <Form formData={formData} validationGroup={validationGroup} colCount={3}> <SimpleItem isRequired dataField='adultsCount' editorType='dxNumberBox' editorOptions={{ elementAttr: { id: 'adultsCount' }, showSpinButtons: true, min: 0, max: 5, }} label={{ text: 'Adults', location: 'top' }} > <RangeRule min={1} /> </SimpleItem> <SimpleItem dataField='childrenCount' editorType='dxNumberBox' editorOptions={{ showSpinButtons: true, min: 0, max: 5 }} label={{ text: 'Children', location: 'top' }} /> <SimpleItem dataField='petsCount' editorType='dxNumberBox' editorOptions={{ showSpinButtons: true, min: 0, max: 5 }} label={{ text: 'Pets', location: 'top' }} /> </Form> </> )); GuestsForm.displayName = 'GuestsForm'; export default GuestsForm;
import React, { memo } from 'react'; import type { FC } from 'react'; import 'devextreme-react/select-box'; import { Form, SimpleItem } from 'devextreme-react/form'; import type { FormProps } from './types.ts'; import { mealPlans, roomTypes } from './data.ts'; const RoomMealPlanForm: FC<FormProps> = memo(({ formData, validationGroup }: FormProps) => ( <> <p> Review room types that can accommodate your group size and make your selection. You can also choose a meal plan, whether it's breakfast only or full board. </p> <Form formData={formData} validationGroup={validationGroup} colCount={2}> <SimpleItem dataField='roomType' isRequired editorType='dxSelectBox' label={{ text: 'Room Type', location: 'top' }} editorOptions={{ items: roomTypes, elementAttr: { id: 'roomType' }, }} /> <SimpleItem dataField='mealPlan' isRequired editorType='dxSelectBox' label={{ text: 'Meal Plan', location: 'top' }} editorOptions={{ items: mealPlans, elementAttr: { id: 'mealPlan' }, }} /> </Form> </> )); RoomMealPlanForm.displayName = 'RoomMealPlanForm'; export default RoomMealPlanForm;
import React from 'react'; import ReactDOM from 'react-dom'; import themes from 'devextreme/ui/themes'; import App from './App.tsx'; themes.initialized(() => { ReactDOM.render( <App />, document.getElementById('app'), ); });
import type { StepperTypes } from 'devextreme-react/stepper'; import type { BookingFormData } from './types'; export const initialSteps: StepperTypes.Item[] = [ { label: 'Dates', hint: 'Dates', icon: 'daterangepicker', }, { label: 'Guests', hint: 'Guests', icon: 'group', }, { label: 'Room and Meal Plan', hint: 'Room and Meal Plan', icon: 'servicebell', }, { label: 'Additional Requests', hint: 'Additional Requests', icon: 'clipboardtasklist', optional: true, }, { label: 'Confirmation', hint: 'Confirmation', icon: 'checkmarkcircle', }, ]; export const roomTypes: string[] = ['Single', 'Double', 'Suite']; export const mealPlans: string[] = ['Bed & Breakfast', 'Half Board', 'Full Board', 'All-Inclusive']; export const initialFormData: BookingFormData = { dates: [null, null], adultsCount: 0, childrenCount: 0, petsCount: 0, roomType: undefined, mealPlan: undefined, additionalRequest: '', }; export const getInitialFormData = (): BookingFormData => ({ ...initialFormData, dates: [...initialFormData.dates], });
export interface BookingFormData { dates: (Date | null)[]; adultsCount: number; childrenCount: number; petsCount: number; roomType: string | undefined; mealPlan: string | undefined; additionalRequest: string; } export interface FormProps { formData: BookingFormData; validationGroup?: string; }
window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, jsx: 'react', }, meta: { 'react': { 'esModule': true, }, 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, }, paths: { 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, defaultExtension: 'js', map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs', 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme-react/common': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" } };
import React, { memo } from 'react'; import 'devextreme-react/text-area'; import { Form, SimpleItem } from 'devextreme-react/form'; const AdditionalForm = memo(({ formData }) => ( <> <div>Please let us know if you have any other requests.</div> <Form formData={formData}> <SimpleItem dataField="additionalRequest" editorType="dxTextArea" editorOptions={{ height: 160, elementAttr: { id: 'additionalRequest' }, }} label={{ visible: false }} ></SimpleItem> </Form> </> )); AdditionalForm.displayName = 'AdditionalForm'; export default AdditionalForm;
import React from 'react'; import 'devextreme-react/date-range-box'; const Confirmation = ({ formData, isConfirmed }) => { if (isConfirmed) { return <div className="summary-item-header center">Your booking request was submitted.</div>; } return ( <div className="summary-container"> <div className="summary-item"> <div className="summary-item-header">Dates</div> <div className="separator"></div> <div> <span className="summary-item-label">Check-in Date: </span> {new Date(formData.dates[0] ?? '').toLocaleDateString()} </div> <div> <span className="summary-item-label">Check-out Date: </span> {new Date(formData.dates[1] ?? '').toLocaleDateString()} </div> </div> <div className="summary-item"> <div className="summary-item-header">Guests</div> <div className="separator"></div> <div> <span className="summary-item-label">Adults: </span> {formData.adultsCount} </div> <div> <span className="summary-item-label">Children: </span> {formData.childrenCount} </div> <div> <span className="summary-item-label">Pets: </span> {formData.petsCount} </div> </div> <div className="summary-item"> <div className="summary-item-header">Room and Meals</div> <div className="separator"></div> <div> <span className="summary-item-label">Room Type: </span> {formData.roomType} </div> <div> <span className="summary-item-label">Check-out Date: </span> {formData.mealPlan} </div> </div> {!!formData.additionalRequest && ( <div className="summary-item"> <div className="summary-item-header">Additional Requests</div> <div className="separator"></div> <div>{formData.additionalRequest}</div> </div> )} </div> ); }; Confirmation.displayName = 'Confirmation'; export default Confirmation;
import React, { memo } from 'react'; import 'devextreme-react/date-range-box'; import { Form, SimpleItem } from 'devextreme-react/form'; const DatesForm = memo(({ formData, validationGroup }) => ( <> <p> Select your check-in and check-out dates. If your dates are flexible, include that information in Additional Requests. We will do our best to suggest best pricing options, depending on room availability. </p> <Form formData={formData} validationGroup={validationGroup} > <SimpleItem isRequired dataField="dates" editorType="dxDateRangeBox" editorOptions={{ startDatePlaceholder: 'Check-in', endDatePlaceholder: 'Check-out', elementAttr: { id: 'datesPicker' }, }} label={{ visible: false }} /> </Form> </> )); DatesForm.displayName = 'DatesForm'; export default DatesForm;
import React, { memo } from 'react'; import { Form, RangeRule, SimpleItem } from 'devextreme-react/form'; import 'devextreme-react/number-box'; const GuestsForm = memo(({ formData, validationGroup }) => ( <> <p> Enter the number of adults, children, and pets staying in the room. This information help us suggest suitable room types, number of beds, and included amenities. </p> <Form formData={formData} validationGroup={validationGroup} colCount={3} > <SimpleItem isRequired dataField="adultsCount" editorType="dxNumberBox" editorOptions={{ elementAttr: { id: 'adultsCount' }, showSpinButtons: true, min: 0, max: 5, }} label={{ text: 'Adults', location: 'top' }} > <RangeRule min={1} /> </SimpleItem> <SimpleItem dataField="childrenCount" editorType="dxNumberBox" editorOptions={{ showSpinButtons: true, min: 0, max: 5 }} label={{ text: 'Children', location: 'top' }} /> <SimpleItem dataField="petsCount" editorType="dxNumberBox" editorOptions={{ showSpinButtons: true, min: 0, max: 5 }} label={{ text: 'Pets', location: 'top' }} /> </Form> </> )); GuestsForm.displayName = 'GuestsForm'; export default GuestsForm;
import React, { memo } from 'react'; import 'devextreme-react/select-box'; import { Form, SimpleItem } from 'devextreme-react/form'; import { mealPlans, roomTypes } from './data.js'; const RoomMealPlanForm = memo(({ formData, validationGroup }) => ( <> <p> Review room types that can accommodate your group size and make your selection. You can also choose a meal plan, whether it's breakfast only or full board. </p> <Form formData={formData} validationGroup={validationGroup} colCount={2} > <SimpleItem dataField="roomType" isRequired editorType="dxSelectBox" label={{ text: 'Room Type', location: 'top' }} editorOptions={{ items: roomTypes, elementAttr: { id: 'roomType' }, }} /> <SimpleItem dataField="mealPlan" isRequired editorType="dxSelectBox" label={{ text: 'Meal Plan', location: 'top' }} editorOptions={{ items: mealPlans, elementAttr: { id: 'mealPlan' }, }} /> </Form> </> )); RoomMealPlanForm.displayName = 'RoomMealPlanForm'; export default RoomMealPlanForm;
import React from 'react'; import ReactDOM from 'react-dom'; import themes from 'devextreme/ui/themes'; import App from './App.js'; themes.initialized(() => { ReactDOM.render(<App />, document.getElementById('app')); });
export const initialSteps = [ { label: 'Dates', hint: 'Dates', icon: 'daterangepicker', }, { label: 'Guests', hint: 'Guests', icon: 'group', }, { label: 'Room and Meal Plan', hint: 'Room and Meal Plan', icon: 'servicebell', }, { label: 'Additional Requests', hint: 'Additional Requests', icon: 'clipboardtasklist', optional: true, }, { label: 'Confirmation', hint: 'Confirmation', icon: 'checkmarkcircle', }, ]; export const roomTypes = ['Single', 'Double', 'Suite']; export const mealPlans = ['Bed & Breakfast', 'Half Board', 'Full Board', 'All-Inclusive']; export const initialFormData = { dates: [null, null], adultsCount: 0, childrenCount: 0, petsCount: 0, roomType: undefined, mealPlan: undefined, additionalRequest: '', }; export const getInitialFormData = () => ({ ...initialFormData, dates: [...initialFormData.dates], });
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
.demo-container { min-height: 580px; } #app { display: flex; flex-direction: column; justify-content: center; row-gap: 20px; height: 580px; min-width: 620px; } .content { padding-inline: 40px; flex: 1; display: flex; flex-direction: column; row-gap: 20px; } .dx-multiview-item-content:has(> .summary-container) { overflow: auto; } .summary-container { display: flex; flex-direction: column; row-gap: 20px; } .summary-item { display: flex; flex-direction: column; row-gap: 8px; } .summary-item-header { font-weight: 600; font-size: var(--dx-font-size-sm); } .center { text-align: center; } .summary-item-label { color: var(--dx-color-icon); } .separator { width: 100%; height: 1px; border-bottom: solid 1px var(--dx-color-border); } .nav-panel { display: flex; align-items: center; justify-content: space-between; } .current-step { color: var(--dx-color-icon); } .nav-buttons { display: flex; gap: 8px; } .readonly { pointer-events: none; }

Validation

Form validation impacts step progression and view switch operations. Attempting to proceed by clicking a step (onSelectionChanging) or pressing "Next" (onClick) triggers the validation process (validateStep) for current step input.

Valid data changes the current step to display a checkmark, selects the next step, and updates the view to the following form. Invalid data prompts error messages, marks the step as invalid, and prevents step progress. Only validated steps allow progression.

To view validation in action, move to step two without "Check-in" and "Check-out" dates. Required fields will fail validation, marking step one as invalid (isValid = false). The icon turns red and displays an exclamation mark. The DateRangeBox component also displays an error icon. DateRangeBox and Stepper both display validation errors since they belong to the same validation group.

The final step is unique. Once the "Additional Requests" step is completed, the request is submitted, and a return to previous steps is not permitted. Click "Reset" to restart booking.

<dx-stepper
[focusStateEnabled]="!isStepperReadonly"
[class.readonly]="isStepperReadonly"
[(selectedIndex)]="selectedIndex"
(onSelectionChanging)="onSelectionChanging($event)"
>
@for (step of steps; track step) {
<dxi-stepper-item
[label]="step.label"
[icon]="step.icon"
[isValid]="step.isValid"
[hint]="step.hint"
[optional]="step.optional"
></dxi-stepper-item>
}
</dx-stepper>
<div class="content">
<dx-multi-view
[(selectedIndex)]="selectedIndex"
[animationEnabled]="false"
[focusStateEnabled]="false"
[swipeEnabled]="false"
[height]="400"
>
<dxi-multi-view-item>
<div *dxTemplate>
<dates-form
[formData]="formData"
[validationGroup]="validationGroups[0]"
></dates-form>
</div>
</dxi-multi-view-item>
<dxi-multi-view-item>
<div *dxTemplate>
<guests-form
[formData]="formData"
[validationGroup]="validationGroups[1]"
></guests-form>
</div>
</dxi-multi-view-item>
<dxi-multi-view-item>
<div *dxTemplate>
<room-meal-plan-form
[formData]="formData"
[validationGroup]="validationGroups[2]"
></room-meal-plan-form>
</div>
</dxi-multi-view-item>
<dxi-multi-view-item>
<div *dxTemplate>
<additional-form [formData]="formData"></additional-form>
</div>
</dxi-multi-view-item>
<dxi-multi-view-item>
<div *dxTemplate>
<confirmation
[formData]="formData"
[isConfirmed]="isConfirmed"
></confirmation>
</div>
</dxi-multi-view-item>
</dx-multi-view>
<div class="nav-panel">
<div class="current-step">
@if (!isConfirmed) {
<span>
Step <span class="selected-index">{{ selectedIndex + 1 }}</span> of
{{ steps.length }}
</span>
}
</div>
<div class="nav-buttons">
<dx-button
id="prevButton"
[visible]="selectedIndex !== 0 && !isConfirmed"
text="Back"
type="normal"
(onClick)="onPrevButtonClick()"
[width]="100"
>
</dx-button>
<dx-button
id="nextButton"
[text]="getNextButtonText()"
type="default"
(onClick)="onNextButtonClick()"
[width]="100"
>
</dx-button>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import {
ChangeDetectionStrategy,
Component,
enableProdMode,
provideZoneChangeDetection,
} from '@angular/core';
import {
DxButtonModule,
DxMultiViewModule,
} from 'devextreme-angular';
import { DxStepperModule, type DxStepperTypes } from 'devextreme-angular/ui/stepper';
import validationEngine from 'devextreme/ui/validation_engine';
import { AppService } from './app.service';
import type { BookingFormData } from './app.types';
import { DatesFormComponent } from './dates-form/dates-form.component';
import { GuestsFormComponent } from './guests-form/guests-form.component';
import { RoomMealPlanFormComponent } from './room-meal-plan-form/room-meal-plan-form.component';
import { AdditionalFormComponent } from './additional-form/additional-form.component';
import { ConfirmationComponent } from './confirmation/confirmation.component';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
changeDetection: ChangeDetectionStrategy.Eager,
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxButtonModule,
DxMultiViewModule,
DxStepperModule,
DatesFormComponent,
GuestsFormComponent,
RoomMealPlanFormComponent,
AdditionalFormComponent,
ConfirmationComponent,
],
})
export class AppComponent {
steps: DxStepperTypes.Item[];
formData: BookingFormData;
selectedIndex: number;
isConfirmed: boolean;
isStepperReadonly: boolean;
validationGroups = ['dates', 'guests', 'roomAndMealPlan'];
constructor(private readonly appService: AppService) {
this.steps = this.appService.getInitialSteps();
this.formData = this.appService.getInitialFormData();
this.selectedIndex = 0;
this.isConfirmed = false;
this.isStepperReadonly = false;
}
getValidationResult(index: number) {
if (index >= this.validationGroups.length) {
return true;
}
return validationEngine.validateGroup(this.validationGroups[index]).isValid;
}
setStepValidationResult(index: number, isValid: boolean | undefined) {
this.steps[index].isValid = isValid;
}
onSelectionChanging(e: DxStepperTypes.SelectionChangingEvent) {
const { component, addedItems, removedItems } = e;
const { items = [] } = component.option();
const addedIndex = items.findIndex((item: DxStepperTypes.Item) => item === addedItems[0]);
const removedIndex = items.findIndex((item: DxStepperTypes.Item) => item === removedItems[0]);
const isMoveForward = removedIndex > -1 && addedIndex > removedIndex;
if (isMoveForward) {
const isValid = this.getValidationResult(removedIndex);
this.setStepValidationResult(removedIndex, isValid);
if (isValid === false) {
e.cancel = true;
}
}
}
getNextButtonText() {
if (this.selectedIndex < this.steps.length - 1) {
return 'Next';
}
return this.isConfirmed ? 'Reset' : 'Confirm';
}
onPrevButtonClick() {
this.selectedIndex -= 1;
}
moveNext() {
const isValid = this.getValidationResult(this.selectedIndex);
this.setStepValidationResult(this.selectedIndex, isValid);
if (isValid) {
this.selectedIndex += 1;
}
}
reset() {
this.isConfirmed = false;
this.selectedIndex = 0;
this.steps = this.appService.getInitialSteps();
this.formData = this.appService.getInitialFormData();
this.isStepperReadonly = false;
}
confirm() {
this.isConfirmed = true;
this.setStepValidationResult(this.selectedIndex, true);
this.isStepperReadonly = true;
}
onNextButtonClick() {
if (this.selectedIndex < this.steps.length - 1) {
this.moveNext();
} else if (this.isConfirmed) {
this.reset();
} else {
this.confirm();
}
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
AppService,
],
});
::ng-deep .demo-container {
min-height: 580px;
}
::ng-deep demo-app {
display: flex;
flex-direction: column;
justify-content: center;
row-gap: 20px;
height: 580px;
min-width: 620px;
}
::ng-deep .content {
padding-inline: 40px;
flex: 1;
display: flex;
flex-direction: column;
row-gap: 20px;
}
::ng-deep .nav-panel {
display: flex;
align-items: center;
justify-content: space-between;
}
::ng-deep .current-step {
color: var(--dx-color-icon);
}
::ng-deep .nav-buttons {
display: flex;
gap: 8px;
}
::ng-deep .readonly {
pointer-events: none;
}
import { Injectable } from '@angular/core';
import { type DxStepperTypes } from 'devextreme-angular/ui/stepper';
import type { BookingFormData } from "./app.types";
@Injectable({
providedIn: 'root',
})
export class AppService {
initialSteps: DxStepperTypes.Item[];
initialFormData: BookingFormData;
roomTypes: string[];
mealPlans: string[];
constructor() {
this.initialSteps = [
{
label: 'Dates', hint: 'Dates', icon: 'daterangepicker',
},
{
label: 'Guests', hint: 'Guests', icon: 'group',
},
{
label: 'Room and Meal Plan', hint: 'Room and Meal Plan', icon: 'servicebell',
},
{
label: 'Additional Requests', hint: 'Additional Requests', icon: 'clipboardtasklist', optional: true,
},
{
label: 'Confirmation', hint: 'Confirmation', icon: 'checkmarkcircle',
},
];
this.initialFormData = {
dates: [null, null],
adultsCount: 0,
childrenCount: 0,
petsCount: 0,
roomType: undefined,
mealPlan: undefined,
additionalRequest: '',
};
}
getInitialSteps(): DxStepperTypes.Item[] {
return this.initialSteps.map((item) => ({ ...item }));
}
getInitialFormData(): BookingFormData {
return {
...this.initialFormData,
dates: [...this.initialFormData.dates],
};
}
}
export interface BookingFormData {
dates: (Date | null)[];
adultsCount: number;
childrenCount: number;
petsCount: number;
roomType: string | undefined;
mealPlan: string | undefined;
additionalRequest: string;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
<div> Please let us know if you have any other requests. </div>
<dx-form [(formData)]="formData">
<dxi-form-item
dataField="additionalRequest"
editorType="dxTextArea"
[editorOptions]="textAreaOptions"
[label]="labelOptions"
>
</dxi-form-item>
</dx-form>
import { Component, Input } from '@angular/core';
import { DxFormModule } from 'devextreme-angular';
import { type DxFormTypes } from 'devextreme-angular/ui/form';
import { type DxTextAreaTypes } from 'devextreme-angular/ui/text-area';
import 'devextreme/ui/text_area';
import type { BookingFormData } from '../app.types';
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'additional-form',
templateUrl: `app/additional-form/additional-form.component.html`,
imports: [
DxFormModule,
],
})
export class AdditionalFormComponent {
@Input() formData: BookingFormData;
textAreaOptions: DxTextAreaTypes.Properties = {
height: 160,
elementAttr: { id: 'additionalRequest' },
};
labelOptions: DxFormTypes.SimpleItem['label'] = {
visible: false,
};
}
::ng-deep .dx-multiview-item-content:has( .summary-container) {
overflow: auto;
}
::ng-deep .summary-container {
display: flex;
flex-direction: column;
row-gap: 20px;
}
::ng-deep .summary-item {
display: flex;
flex-direction: column;
row-gap: 8px;
}
::ng-deep .summary-item-header {
font-weight: 600;
font-size: var(--dx-font-size-sm);
}
::ng-deep .center {
text-align: center;
}
::ng-deep .summary-item-label {
color: var(--dx-color-icon);
}
::ng-deep .separator {
width: 100%;
height: 1px;
border-bottom: solid 1px var(--dx-color-border);
}
@if (isConfirmed) {
<div class="summary-item-header center">
Your booking request was submitted.
</div>
} @else {
<div class="summary-container">
<div class="summary-item">
<div class="summary-item-header">Dates</div>
<div class="separator"></div>
<div>
<span class="summary-item-label">Check-in Date: </span
>{{ getCheckInDate() }}
</div>
<div>
<span class="summary-item-label">Check-out Date: </span
>{{ getCheckOutDate() }}
</div>
</div>
<div class="summary-item">
<div class="summary-item-header">Guests</div>
<div class="separator"></div>
<div
><span class="summary-item-label">Adults: </span
>{{ formData.adultsCount }}</div
>
<div
><span class="summary-item-label">Children: </span
>{{ formData.childrenCount }}</div
>
<div
><span class="summary-item-label">Pets: </span
>{{ formData.petsCount }}</div
>
</div>
<div class="summary-item">
<div class="summary-item-header">Room and Meals</div>
<div class="separator"></div>
<div
><span class="summary-item-label">Room Type: </span
>{{ formData.roomType }}</div
>
<div
><span class="summary-item-label">Check-out Date: </span
>{{ formData.mealPlan }}</div
>
</div>
@if (!!formData.additionalRequest) {
<div class="summary-item">
<div class="summary-item-header">Additional Requests</div>
<div class="separator"></div>
<div>{{ formData.additionalRequest }}</div>
</div>
}
</div>
}
import { ChangeDetectionStrategy, Component, Input } from '@angular/core';
import type { BookingFormData } from '../app.types';
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
changeDetection: ChangeDetectionStrategy.Eager,
selector: 'confirmation',
templateUrl: `app/confirmation/confirmation.component.html`,
styleUrls: [`app/confirmation/confirmation.component.css`],
})
export class ConfirmationComponent {
@Input() formData: BookingFormData;
@Input() isConfirmed: boolean;
getCheckInDate() {
return new Date(this.formData.dates[0]).toLocaleDateString();
}
getCheckOutDate() {
return new Date(this.formData.dates[1]).toLocaleDateString();
}
}
<p>
Select your check-in and check-out dates. If your dates are flexible, include
that information in Additional Requests. We will do our best to suggest best
pricing options, depending on room availability.
</p>
<dx-form
#formComponent
[(formData)]="formData"
[validationGroup]="validationGroup"
>
<dxi-form-item
[isRequired]="true"
dataField="dates"
editorType="dxDateRangeBox"
[editorOptions]="dateRangeBoxOptions"
[label]="labelOptions"
></dxi-form-item>
</dx-form>
import { Component, Input, SimpleChanges, ViewChild } from '@angular/core';
import { DxFormModule } from 'devextreme-angular';
import { DxFormComponent, type DxFormTypes } from 'devextreme-angular/ui/form';
import { type DxDateRangeBoxTypes } from 'devextreme-angular/ui/date-range-box';
import 'devextreme/ui/date_range_box';
import type { BookingFormData } from '../app.types';
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'dates-form',
templateUrl: `app/dates-form/dates-form.component.html`,
imports: [
DxFormModule,
],
})
export class DatesFormComponent {
@ViewChild('formComponent', { static: false }) form!: DxFormComponent;
@Input() formData: BookingFormData;
@Input() validationGroup: string;
ngOnChanges(changes: SimpleChanges) {
if (changes.formData) {
const value = changes.formData.currentValue;
this.form?.instance?.reset(value);
}
}
dateRangeBoxOptions: DxDateRangeBoxTypes.Properties = {
startDatePlaceholder: 'Check-in',
endDatePlaceholder: 'Check-out',
elementAttr: { id: 'datesPicker' },
};
labelOptions: DxFormTypes.SimpleItem['label'] = {
visible: false,
};
}
<p>
Enter the number of adults, children, and pets staying in the room. This
information help us suggest suitable room types, number of beds, and included
amenities.
</p>
<dx-form
#formComponent
[(formData)]="formData"
[validationGroup]="validationGroup"
[colCount]="3"
>
<dxi-form-item
[isRequired]="true"
dataField="adultsCount"
editorType="dxNumberBox"
[editorOptions]="numberBoxOptions"
[label]="adultsLabelOptions"
>
<dxi-form-validation-rule type="range" [min]="1"></dxi-form-validation-rule>
</dxi-form-item>
<dxi-form-item
dataField="childrenCount"
editorType="dxNumberBox"
[editorOptions]="numberBoxOptions"
[label]="childrenLabelOptions"
>
</dxi-form-item>
<dxi-form-item
dataField="petsCount"
editorType="dxNumberBox"
[editorOptions]="numberBoxOptions"
[label]="petsLabelOptions"
>
</dxi-form-item>
</dx-form>
import { Component, Input, SimpleChanges, ViewChild } from '@angular/core';
import { DxFormModule } from 'devextreme-angular';
import { DxFormComponent, type DxFormTypes } from 'devextreme-angular/ui/form';
import { type DxNumberBoxTypes } from 'devextreme-angular/ui/number-box';
import type { BookingFormData } from '../app.types';
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'guests-form',
templateUrl: `app/guests-form/guests-form.component.html`,
imports: [
DxFormModule,
],
})
export class GuestsFormComponent {
@ViewChild('formComponent', { static: false }) form!: DxFormComponent;
@Input() formData: BookingFormData;
@Input() validationGroup: string;
ngOnChanges(changes: SimpleChanges) {
if (changes.formData) {
const value = changes.formData.currentValue;
this.form?.instance?.reset(value);
}
}
adultsLabelOptions: DxFormTypes.SimpleItem['label'] = {
text: 'Adults',
location: 'top',
};
childrenLabelOptions: DxFormTypes.SimpleItem['label'] = {
text: 'Children',
location: 'top',
};
petsLabelOptions: DxFormTypes.SimpleItem['label'] = {
text: 'Pets',
location: 'top',
};
numberBoxOptions: DxNumberBoxTypes.Properties = {
min: 0,
max: 5,
showSpinButtons: true,
elementAttr: { id: 'adultsCount' },
};
}
<p>
Review room types that can accommodate your group size and make your
selection. You can also choose a meal plan, whether it's breakfast only or
full board.
</p>
<dx-form
#formComponent
[(formData)]="formData"
[validationGroup]="validationGroup"
[colCount]="2"
>
<dxi-form-item
[isRequired]="true"
dataField="roomType"
editorType="dxSelectBox"
[editorOptions]="roomSelectBoxOptions"
[label]="roomLabelOptions"
></dxi-form-item>
<dxi-form-item
[isRequired]="true"
dataField="mealPlan"
editorType="dxSelectBox"
[editorOptions]="mealSelectBoxOptions"
[label]="mealLabelOptions"
></dxi-form-item>
</dx-form>
import { Component, Input, SimpleChanges, ViewChild } from '@angular/core';
import { DxFormModule } from 'devextreme-angular';
import { DxFormComponent, type DxFormTypes } from 'devextreme-angular/ui/form';
import { type DxSelectBoxTypes } from 'devextreme-angular/ui/select-box';
import 'devextreme/ui/select_box';
import type { BookingFormData } from '../app.types';
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'room-meal-plan-form',
templateUrl: `app/room-meal-plan-form/room-meal-plan-form.component.html`,
imports: [
DxFormModule,
],
})
export class RoomMealPlanFormComponent {
@ViewChild('formComponent', { static: false }) form!: DxFormComponent;
@Input() formData: BookingFormData;
@Input() validationGroup: string;
ngOnChanges(changes: SimpleChanges) {
if (changes.formData) {
const value = changes.formData.currentValue;
this.form?.instance?.reset(value);
}
}
roomLabelOptions: DxFormTypes.SimpleItem['label'] = {
text: 'Room Type',
location: 'top',
};
mealLabelOptions: DxFormTypes.SimpleItem['label'] = {
text: 'Meal Plan',
location: 'top',
};
roomTypes = ['Single', 'Double', 'Suite'];
mealPlans = ['Bed & Breakfast', 'Half Board', 'Full Board', 'All-Inclusive'];
mealSelectBoxOptions: DxSelectBoxTypes.Properties = {
items: this.mealPlans,
elementAttr: { id: 'mealPlan' },
};
roomSelectBoxOptions: DxSelectBoxTypes.Properties = {
items: this.roomTypes,
elementAttr: { id: 'roomType' },
};
}

<template>
<DxStepper
:focus-state-enabled="!isStepperReadonly"
:class="{ readonly: isStepperReadonly }"
v-model:selected-index="selectedIndex"
@selection-changing="onSelectionChanging"
>
<DxStepperItem
v-for="item of steps"
:label="item.label"
:icon="item.icon"
:is-valid="item.isValid"
:hint="item.hint"
:optional="item.optional"
/>
</DxStepper>
<div class="content">
<DxMultiView
v-model:selected-index="selectedIndex"
:focus-state-enabled="false"
:animation-enabled="false"
:swipe-enabled="false"
:height="400"
>
<DxMultiViewItem>
<template #default>
<DatesTemplate
:form-data="formData"
:validation-group="validationGroups[0]"
/>
</template>
</DxMultiViewItem>
<DxMultiViewItem>
<template #default>
<GuestsTemplate
:form-data="formData"
:validation-group="validationGroups[1]"
/>
</template>
</DxMultiViewItem>
<DxMultiViewItem>
<template #default>
<RoomMealPlanTemplate
:form-data="formData"
:validation-group="validationGroups[2]"
/>
</template>
</DxMultiViewItem>
<DxMultiViewItem>
<template #default>
<AdditionalTemplate :form-data="formData"/>
</template>
</DxMultiViewItem>
<DxMultiViewItem>
<template #default>
<ConfirmationTemplate
:form-data="formData"
v-model:is-confirmed="isConfirmed"
/>
</template>
</DxMultiViewItem>
</DxMultiView>
<div class="nav-panel">
<div class="current-step">
<span v-if="!isConfirmed">
Step <span class="selected-index">{{ selectedIndex + 1 }}</span> of {{ steps.length }}
</span>
</div>
<div class="nav-buttons">
<DxButton
id="prevButton"
:visible="selectedIndex !== 0 && !isConfirmed"
text="Back"
type="normal"
@click="onPrevButtonClick"
:width="100"
/>
<DxButton
id="nextButton"
:text="nextButtonText"
type="default"
@click="onNextButtonClick"
:width="100"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref, computed } from 'vue';
import { DxButton } from 'devextreme-vue/button';
import { DxMultiView, DxItem as DxMultiViewItem } from 'devextreme-vue/multi-view';
import { DxStepper, DxItem as DxStepperItem, type DxStepperTypes } from 'devextreme-vue/stepper';
import validationEngine from 'devextreme/ui/validation_engine';
import DatesTemplate from './DatesTemplate.vue';
import GuestsTemplate from './GuestsTemplate.vue';
import RoomMealPlanTemplate from './RoomMealPlanTemplate.vue';
import AdditionalTemplate from './AdditionalTemplate.vue';
import ConfirmationTemplate from './ConfirmationTemplate.vue';
import { getInitialSteps, getInitialFormData } from './data.ts';
import type { BookingFormData } from './types';
const selectedIndex = ref(0);
const isConfirmed = ref(false);
const isStepperReadonly = ref(false);
const steps = ref<DxStepperTypes.Item[]>(getInitialSteps());
const formData = ref<BookingFormData>(getInitialFormData());
const validationGroups = ['dates', 'guests', 'roomAndMealPlan'];
const nextButtonText = computed(() => {
if (selectedIndex.value < steps.value.length - 1) {
return 'Next';
}
return isConfirmed.value ? 'Reset' : 'Confirm';
});
const getValidationResult = (index: number) => {
if (index >= validationGroups.length) {
return true;
}
return validationEngine.validateGroup(validationGroups[index]).isValid;
};
const setStepValidationResult = (index: number, isValid: boolean | undefined) => {
steps.value[index].isValid = isValid;
};
function onSelectionChanging(e: DxStepperTypes.SelectionChangingEvent) {
const { component, addedItems, removedItems } = e;
const { items = [] } = component.option();
const addedIndex = items.findIndex((item: DxStepperTypes.Item) => item === addedItems[0]);
const removedIndex = items.findIndex((item: DxStepperTypes.Item) => item === removedItems[0]);
const isMoveForward = addedIndex > removedIndex;
if (isMoveForward) {
const isValid = getValidationResult(removedIndex);
setStepValidationResult(removedIndex, isValid);
if (isValid === false) {
e.cancel = true;
}
}
}
function onPrevButtonClick() {
selectedIndex.value -= 1;
}
const moveNext = () => {
const isValid = getValidationResult(selectedIndex.value);
setStepValidationResult(selectedIndex.value, isValid);
if (isValid) {
selectedIndex.value += 1;
}
};
const reset = () => {
isConfirmed.value = false;
selectedIndex.value = 0;
steps.value = getInitialSteps();
formData.value = getInitialFormData();
isStepperReadonly.value = false;
};
const confirm = () => {
isConfirmed.value = true;
setStepValidationResult(selectedIndex.value, true);
isStepperReadonly.value = true;
};
function onNextButtonClick() {
if (selectedIndex.value < steps.value.length - 1) {
moveNext();
} else if (isConfirmed.value) {
reset();
} else {
confirm();
}
}
</script>
<style scoped>
.demo-container {
min-height: 580px;
}
#app {
display: flex;
flex-direction: column;
justify-content: center;
row-gap: 20px;
height: 580px;
min-width: 620px;
}
.content {
padding-inline: 40px;
flex: 1;
display: flex;
flex-direction: column;
row-gap: 20px;
}
.dx-multiview-item-content:has(> .summary-container) {
overflow: auto;
}
.summary-container {
display: flex;
flex-direction: column;
row-gap: 20px;
}
.summary-item {
display: flex;
flex-direction: column;
row-gap: 8px;
}
.summary-item-header {
font-weight: 600;
font-size: var(--dx-font-size-sm);
}
.center {
text-align: center;
}
.summary-item-label {
color: var(--dx-color-icon);
}
.separator {
width: 100%;
height: 1px;
border-bottom: solid 1px var(--dx-color-border);
}
.nav-panel {
display: flex;
align-items: center;
justify-content: space-between;
}
.current-step {
color: var(--dx-color-icon);
}
.nav-buttons {
display: flex;
gap: 8px;
}
.readonly {
pointer-events: none;
}
</style>
<template>
<div>
Please let us know if you have any other requests.
</div>
<DxForm :form-data="formData">
<DxSimpleItem
data-field="additionalRequest"
editor-type="dxTextArea"
:editor-options="textAreaOptions"
:label="labelOptions"
/>
</DxForm>
</template>
<script setup lang="ts">
import { DxForm, DxSimpleItem } from 'devextreme-vue/form';
import 'devextreme-vue/text-area';
import type { BookingFormData } from './types.ts';
import { initialFormData } from './data.ts';
const props = withDefaults(defineProps<{
formData?: BookingFormData;
}>(), {
formData: () => initialFormData,
});
const labelOptions = {
visible: false,
};
const textAreaOptions = {
height: 160,
elementAttr: { id: 'additionalRequest' },
};
</script>
<template>
<div
class="summary-item-header center"
v-if="isConfirmed"
>
Your booking request was submitted.
</div>
<div
class="summary-container"
v-if="!isConfirmed"
>
<div class="summary-item">
<div class="summary-item-header">Dates</div>
<div class="separator"/>
<div>
<span class="summary-item-label">Check-in Date: </span>
{{ formatDate(formData.dates[0]) }}
</div>
<div>
<span class="summary-item-label">Check-out Date: </span>
{{ formatDate(formData.dates[1]) }}
</div>
</div>
<div class="summary-item">
<div class="summary-item-header">Guests</div>
<div class="separator"/>
<div><span class="summary-item-label">Adults: </span>{{ formData.adultsCount }}</div>
<div><span class="summary-item-label">Children: </span>{{ formData.childrenCount }}</div>
<div><span class="summary-item-label">Pets: </span>{{ formData.petsCount }}</div>
</div>
<div class="summary-item">
<div class="summary-item-header">Room and Meals</div>
<div class="separator"/>
<div><span class="summary-item-label">Room Type: </span>{{ formData.roomType }}</div>
<div><span class="summary-item-label">Check-out Date: </span>{{ formData.mealPlan }}</div>
</div>
<div
class="summary-item"
v-if="!!formData.additionalRequest"
>
<div class="summary-item-header">Additional Requests</div>
<div class="separator"/>
<div>{{ formData.additionalRequest }}</div>
</div>
</div>
</template>
<script setup lang="ts">
import type { BookingFormData } from './types.ts';
import { initialFormData } from './data.ts';
const props = withDefaults(defineProps<{
formData?: BookingFormData;
isConfirmed?: boolean;
}>(), {
formData: () => initialFormData,
isConfirmed: () => false,
});
const formatDate = (value: Date | null) => value ? new Date(value).toLocaleDateString() : '';
</script>
<template>
<p>
Select your check-in and check-out dates.
If your dates are flexible, include that information in Additional Requests.
We will do our best to suggest best pricing options, depending on room availability.
</p>
<DxForm
:form-data="formData"
:validation-group="validationGroup"
ref="formRef"
>
<DxSimpleItem
:is-required="true"
data-field="dates"
editor-type="dxDateRangeBox"
:editor-options="dateRangeBoxOptions"
:label="labelOptions"
/>
</DxForm>
</template>
<script setup lang="ts">
import DxForm, { DxSimpleItem } from 'devextreme-vue/form';
import 'devextreme-vue/date-range-box';
import { ref, watch } from 'vue';
import type { BookingFormData } from './types.ts';
import { getInitialFormData } from './data.ts';
const formRef = ref<DxForm>();
const props = withDefaults(defineProps<{
formData?: BookingFormData;
validationGroup?: string;
}>(), {
formData: getInitialFormData,
validationGroup: () => '',
});
watch(() => props.formData, (value) => {
formRef.value?.instance?.reset(value);
});
const labelOptions = {
visible: false,
};
const dateRangeBoxOptions = {
startDatePlaceholder: 'Check-in',
endDatePlaceholder: 'Check-out',
elementAttr: { id: 'datesPicker' },
};
</script>
<template>
<p>
Enter the number of adults, children, and pets staying in the room.
This information help us suggest suitable room types, number of beds,
and included amenities.
</p>
<DxForm
:form-data="formData"
:validation-group="validationGroup"
:col-count="3"
ref="formRef"
>
<DxSimpleItem
:is-required="true"
data-field="adultsCount"
editor-type="dxNumberBox"
:editor-options="adultsNumberBoxOptions"
:label="adultsLabelOptions"
>
<DxRangeRule :min="1"/>
</DxSimpleItem>
<DxSimpleItem
data-field="childrenCount"
editor-type="dxNumberBox"
:editor-options="numberBoxOptions"
:label="childrenLabelOptions"
/>
<DxSimpleItem
data-field="petsCount"
editor-type="dxNumberBox"
:editor-options="numberBoxOptions"
:label="petsLabelOptions"
/>
</DxForm>
</template>
<script setup lang="ts">
import { DxForm, DxRangeRule, DxSimpleItem } from 'devextreme-vue/form';
import 'devextreme-vue/number-box';
import { watch, ref } from 'vue';
import type { BookingFormData } from './types.ts';
import { getInitialFormData } from './data.ts';
const formRef = ref<DxForm>();
const props = withDefaults(defineProps<{
formData?: BookingFormData;
validationGroup?: string;
}>(), {
formData: getInitialFormData,
validationGroup: () => '',
});
watch(() => props.formData, (value) => {
formRef.value?.instance?.reset(value);
});
const adultsLabelOptions = {
text: 'Adults',
location: 'top',
};
const childrenLabelOptions = {
text: 'Children',
location: 'top',
};
const petsLabelOptions = {
text: 'Pets',
location: 'top',
};
const numberBoxOptions = {
min: 0,
max: 5,
showSpinButtons: true,
};
const adultsNumberBoxOptions = {
...numberBoxOptions,
elementAttr: { id: 'adultsCount' },
};
</script>
<template>
<p>
Review room types that can accommodate your group size and make your selection.
You can also choose a meal plan, whether it's breakfast only or full board.
</p>
<DxForm
:form-data="formData"
:validation-group="validationGroup"
:col-count="2"
ref="formRef"
>
<DxSimpleItem
:is-required="true"
data-field="roomType"
editor-type="dxSelectBox"
:editor-options="roomSelectBoxOptions"
:label="roomLabelOptions"
/>
<DxSimpleItem
:is-required="true"
data-field="mealPlan"
editor-type="dxSelectBox"
:editor-options="mealSelectBoxOptions"
:label="mealLabelOptions"
/>
</DxForm>
</template>
<script setup lang="ts">
import DxForm, { DxSimpleItem } from 'devextreme-vue/form';
import 'devextreme-vue/select-box';
import { watch, ref } from 'vue';
import type { BookingFormData } from './types.ts';
import { roomTypes, mealPlans, getInitialFormData } from './data.ts';
const formRef = ref<DxForm>();
const props = withDefaults(defineProps<{
formData?: BookingFormData;
validationGroup?: string;
}>(), {
formData: getInitialFormData,
validationGroup: () => '',
});
watch(() => props.formData, (value) => {
formRef.value?.instance?.reset(value);
});
const roomLabelOptions = {
text: 'Room Type',
location: 'top',
};
const roomSelectBoxOptions = {
items: roomTypes,
elementAttr: { id: 'roomType' },
};
const mealLabelOptions = {
text: 'Meal Plan',
location: 'top',
};
const mealSelectBoxOptions = {
items: mealPlans,
elementAttr: { id: 'mealPlan' },
};
</script>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { type DxStepperTypes } from 'devextreme-vue/stepper';
import type { BookingFormData } from './types';
export const initialSteps: DxStepperTypes.Item[] = [
{
label: 'Dates', hint: 'Dates', icon: 'daterangepicker',
},
{
label: 'Guests', hint: 'Guests', icon: 'group',
},
{
label: 'Room and Meal Plan', hint: 'Room and Meal Plan', icon: 'servicebell',
},
{
label: 'Additional Requests', hint: 'Additional Requests', icon: 'clipboardtasklist', optional: true,
},
{
label: 'Confirmation', hint: 'Confirmation', icon: 'checkmarkcircle',
},
];
export const roomTypes = ['Single', 'Double', 'Suite'];
export const mealPlans = ['Bed & Breakfast', 'Half Board', 'Full Board', 'All-Inclusive'];
export const initialFormData: BookingFormData = {
dates: [null, null],
adultsCount: 0,
childrenCount: 0,
petsCount: 0,
roomType: undefined,
mealPlan: undefined,
additionalRequest: '',
};
export const getInitialSteps = () => initialSteps.map((item) => ({ ...item }));
export const getInitialFormData = () => ({
...initialFormData,
dates: [...initialFormData.dates],
});
import { createApp } from 'vue';
import themes from 'devextreme/ui/themes';
import App from './App.vue';
themes.initialized(() => createApp(App).mount('#app'));
export interface BookingFormData {
dates: (Date | null)[];
adultsCount: number;
childrenCount: number;
petsCount: number;
roomType: string | undefined;
mealPlan: string | undefined;
additionalRequest: string;
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>